Solid Example: Stores

import { render } from 'solid-js/web'
import { createStore, useSelector } from '@tanstack/solid-store'

// Optionally, you can create stores outside of Solid components at module scope
const petStore = createStore({
  cats: 0,
  dogs: 0,
})

function App() {
  return (
    <main>
      <h1>Solid Store Hooks</h1>
      <p>
        This example creates a module-level store. Components read state with
        `useSelector` and update it directly with `store.setState`.
      </p>
      <CatsCard />
      <DogsCard />
      <TotalCard />
      <StoreButtons />
    </main>
  )
}

function CatsCard() {
  // read state slice (only re-renders when the selected value changes)
  const value = useSelector(petStore, (state) => state.cats)

  return <p>Cats: {value()}</p>
}

function DogsCard() {
  // read state slice (only re-renders when the selected value changes)
  const value = useSelector(petStore, (state) => state.dogs)

  return <p>Dogs: {value()}</p>
}

function StoreButtons() {
  return (
    <div>
      <button
        type="button"
        onClick={() =>
          petStore.setState((prev) => ({
            ...prev,
            cats: prev.cats + 1,
          }))
        }
      >
        Add cat
      </button>
      <button
        type="button"
        onClick={() =>
          // directly update values in the store
          petStore.setState((prev) => ({
            ...prev,
            dogs: prev.dogs + 1,
          }))
        }
      >
        Add dog
      </button>
    </div>
  )
}

function TotalCard() {
  const total = useSelector(petStore, (state) => state.cats + state.dogs)

  return <p>Total votes: {total()}</p>
}

render(() => <App />, document.getElementById('root')!)
import { render } from 'solid-js/web'
import { createStore, useSelector } from '@tanstack/solid-store'

// Optionally, you can create stores outside of Solid components at module scope
const petStore = createStore({
  cats: 0,
  dogs: 0,
})

function App() {
  return (
    <main>
      <h1>Solid Store Hooks</h1>
      <p>
        This example creates a module-level store. Components read state with
        `useSelector` and update it directly with `store.setState`.
      </p>
      <CatsCard />
      <DogsCard />
      <TotalCard />
      <StoreButtons />
    </main>
  )
}

function CatsCard() {
  // read state slice (only re-renders when the selected value changes)
  const value = useSelector(petStore, (state) => state.cats)

  return <p>Cats: {value()}</p>
}

function DogsCard() {
  // read state slice (only re-renders when the selected value changes)
  const value = useSelector(petStore, (state) => state.dogs)

  return <p>Dogs: {value()}</p>
}

function StoreButtons() {
  return (
    <div>
      <button
        type="button"
        onClick={() =>
          petStore.setState((prev) => ({
            ...prev,
            cats: prev.cats + 1,
          }))
        }
      >
        Add cat
      </button>
      <button
        type="button"
        onClick={() =>
          // directly update values in the store
          petStore.setState((prev) => ({
            ...prev,
            dogs: prev.dogs + 1,
          }))
        }
      >
        Add dog
      </button>
    </div>
  )
}

function TotalCard() {
  const total = useSelector(petStore, (state) => state.cats + state.dogs)

  return <p>Total votes: {total()}</p>
}

render(() => <App />, document.getElementById('root')!)

<script setup lang="ts">
import { createStore, useSelector } from '@tanstack/vue-store'

// Optionally, you can create stores outside of Vue components at module scope
const petStore = createStore({
  cats: 0,
  dogs: 0,
})

// read state slice (only re-renders when the selected value changes)
const cats = useSelector(petStore, (state) => state.cats)
const dogs = useSelector(petStore, (state) => state.dogs)
const total = useSelector(petStore, (state) => state.cats + state.dogs)

function addCat() {
  petStore.setState((prev) => ({
    ...prev,
    cats: prev.cats + 1,
  }))
}

function addDog() {
  // directly update values in the store
  petStore.setState((prev) => ({
    ...prev,
    dogs: prev.dogs + 1,
  }))
}
</script>

<template>
  <main>
    <h1>Vue Store Hooks</h1>
    <p>
      This example creates a module-level store. Components read state with
      `useSelector` and update it directly with `store.setState`.
    </p>
    <p>Cats: {{ cats }}</p>
    <p>Dogs: {{ dogs }}</p>
    <p>Total votes: {{ total }}</p>
    <div>
      <button type="button" @click="addCat">Add cat</button>
      <button type="button" @click="addDog">Add dog</button>
    </div>
  </main>
</template>
<script setup lang="ts">
import { createStore, useSelector } from '@tanstack/vue-store'

// Optionally, you can create stores outside of Vue components at module scope
const petStore = createStore({
  cats: 0,
  dogs: 0,
})

// read state slice (only re-renders when the selected value changes)
const cats = useSelector(petStore, (state) => state.cats)
const dogs = useSelector(petStore, (state) => state.dogs)
const total = useSelector(petStore, (state) => state.cats + state.dogs)

function addCat() {
  petStore.setState((prev) => ({
    ...prev,
    cats: prev.cats + 1,
  }))
}

function addDog() {
  // directly update values in the store
  petStore.setState((prev) => ({
    ...prev,
    dogs: prev.dogs + 1,
  }))
}
</script>

<template>
  <main>
    <h1>Vue Store Hooks</h1>
    <p>
      This example creates a module-level store. Components read state with
      `useSelector` and update it directly with `store.setState`.
    </p>
    <p>Cats: {{ cats }}</p>
    <p>Dogs: {{ dogs }}</p>
    <p>Total votes: {{ total }}</p>
    <div>
      <button type="button" @click="addCat">Add cat</button>
      <button type="button" @click="addDog">Add dog</button>
    </div>
  </main>
</template>

Angular Example: Stores

import { Component } from '@angular/core'
import { createStore, injectSelector } from '@tanstack/angular-store'

// Optionally, you can create stores outside of Angular components at module scope
const petStore = createStore({
  cats: 0,
  dogs: 0,
})

@Component({
  selector: 'app-root',
  standalone: true,
  template: `
    <main>
      <h1>Angular Store Hooks</h1>
      <p>
        This example creates a module-level store. Components read state with
        \`injectSelector\` and update it directly with \`store.setState\`.
      </p>
      <p>Cats: {{ cats() }}</p>
      <p>Dogs: {{ dogs() }}</p>
      <p>Total votes: {{ total() }}</p>
      <div>
        <button type="button" (click)="addCat()">Add cat</button>
        <button type="button" (click)="addDog()">Add dog</button>
      </div>
    </main>
  `,
})
export class AppComponent {
  cats = injectSelector(petStore, (state) => state.cats)
  dogs = injectSelector(petStore, (state) => state.dogs)
  total = injectSelector(petStore, (state) => state.cats + state.dogs)

  addCat() {
    petStore.setState((prev) => ({
      ...prev,
      cats: prev.cats + 1,
    }))
  }

  addDog() {
    // directly update values in the store
    petStore.setState((prev) => ({
      ...prev,
      dogs: prev.dogs + 1,
    }))
  }
}
import { Component } from '@angular/core'
import { createStore, injectSelector } from '@tanstack/angular-store'

// Optionally, you can create stores outside of Angular components at module scope
const petStore = createStore({
  cats: 0,
  dogs: 0,
})

@Component({
  selector: 'app-root',
  standalone: true,
  template: `
    <main>
      <h1>Angular Store Hooks</h1>
      <p>
        This example creates a module-level store. Components read state with
        \`injectSelector\` and update it directly with \`store.setState\`.
      </p>
      <p>Cats: {{ cats() }}</p>
      <p>Dogs: {{ dogs() }}</p>
      <p>Total votes: {{ total() }}</p>
      <div>
        <button type="button" (click)="addCat()">Add cat</button>
        <button type="button" (click)="addDog()">Add dog</button>
      </div>
    </main>
  `,
})
export class AppComponent {
  cats = injectSelector(petStore, (state) => state.cats)
  dogs = injectSelector(petStore, (state) => state.dogs)
  total = injectSelector(petStore, (state) => state.cats + state.dogs)

  addCat() {
    petStore.setState((prev) => ({
      ...prev,
      cats: prev.cats + 1,
    }))
  }

  addDog() {
    // directly update values in the store
    petStore.setState((prev) => ({
      ...prev,
      dogs: prev.dogs + 1,
    }))
  }
}